Index: demo/coloring.cc
===================================================================
--- demo/coloring.cc	(revision 2116)
+++ demo/coloring.cc	(revision 2172)
@@ -98,9 +98,9 @@
   }
 
-  ColorSet colorSet;
+  Palette palette;
 
   graphToEps(graph, "coloring.eps").
     title("Six Colored Plan Graph").copyright("(C) 2006 LEMON Project").
-    coords(coords).nodeColors(composeMap(colorSet, color)).
+    coords(coords).nodeColors(composeMap(palette, color)).
     nodeScale(5.0).scaleToA4().run();
 
Index: demo/graph_orientation.cc
===================================================================
--- demo/graph_orientation.cc	(revision 2158)
+++ demo/graph_orientation.cc	(revision 2172)
@@ -26,11 +26,5 @@
 using namespace lemon;
  
-
-typedef ListGraph::Node Node;
-typedef ListGraph::NodeIt NodeIt;
-typedef ListGraph::Edge Edge;
-typedef ListGraph::EdgeIt EdgeIt;
-typedef ListGraph::OutEdgeIt OutEdgeIt;
-typedef ListGraph::InEdgeIt InEdgeIt;
+GRAPH_TYPEDEFS(ListGraph)
 
 int main(int argc, char** argv) 
@@ -114,5 +108,5 @@
     coords(coords).
     negateY().
-    edgeColors(composeMap(ColorSet(),rev)).
+    edgeColors(composeMap(Palette(),rev)).
     edgeWidthScale(1).
     nodeTexts(f).nodeTextSize(20).
Index: demo/graph_to_eps_demo.cc
===================================================================
--- demo/graph_to_eps_demo.cc	(revision 1956)
+++ demo/graph_to_eps_demo.cc	(revision 2172)
@@ -42,5 +42,5 @@
 int main()
 {
-  ColorSet colorSet;
+  Palette palette;
 
   ListGraph g;
@@ -89,6 +89,6 @@
     nodeScale(2).nodeSizes(sizes).
     nodeShapes(shapes).
-    nodeColors(composeMap(colorSet,colors)).
-    edgeColors(composeMap(colorSet,ecolors)).
+    nodeColors(composeMap(palette,colors)).
+    edgeColors(composeMap(palette,ecolors)).
     edgeWidthScale(.4).edgeWidths(widths).
     nodeTexts(id).nodeTextSize(3).
@@ -101,9 +101,9 @@
     title("Sample .eps figure (with arrowheads)").
     copyright("(C) 2006 LEMON Project").
-    nodeColors(composeMap(colorSet,colors)).
+    nodeColors(composeMap(palette,colors)).
     coords(coords).
     nodeScale(2).nodeSizes(sizes).
     nodeShapes(shapes).
-    edgeColors(composeMap(colorSet,ecolors)).
+    edgeColors(composeMap(palette,ecolors)).
     edgeWidthScale(.4).edgeWidths(widths).
     nodeTexts(id).nodeTextSize(3).
@@ -130,6 +130,6 @@
     coords(coords).
     nodeScale(2).nodeSizes(sizes).
-    nodeColors(composeMap(colorSet,colors)).
-    edgeColors(composeMap(colorSet,ecolors)).
+    nodeColors(composeMap(palette,colors)).
+    edgeColors(composeMap(palette,ecolors)).
     edgeWidthScale(.4).edgeWidths(widths).
     nodeTexts(id).nodeTextSize(3).
@@ -145,6 +145,6 @@
     coords(coords).
     nodeShapes(shapes).
-    nodeColors(composeMap(colorSet,colors)).
-    edgeColors(composeMap(colorSet,ecolors)).
+    nodeColors(composeMap(palette,colors)).
+    edgeColors(composeMap(palette,ecolors)).
     edgeWidthScale(.3).edgeWidths(widths).
     nodeTexts(id).nodeTextSize(3).
@@ -160,6 +160,6 @@
     coords(coords).
     nodeShapes(shapes).
-    nodeColors(composeMap(colorSet,colors)).
-    edgeColors(composeMap(colorSet,ecolors)).
+    nodeColors(composeMap(palette,colors)).
+    edgeColors(composeMap(palette,ecolors)).
     edgeWidthScale(.3).edgeWidths(widths).
     nodeTexts(id).nodeTextSize(3).
@@ -172,6 +172,6 @@
   ListGraph::NodeMap<Xy> hcoords(h);
   
-  int cols=int(sqrt(double(colorSet.size())));
-  for(int i=0;i<int(colorSet.size());i++) {
+  int cols=int(sqrt(double(palette.size())));
+  for(int i=0;i<int(palette.size());i++) {
     Node n=h.addNode();
     hcoords[n]=Xy(i%cols,i/cols);
@@ -182,5 +182,5 @@
   graphToEps(h,"graph_to_eps_demo_out_colors.eps").
     //scale(60).
-    title("Sample .eps figure (ColorSet demo)").
+    title("Sample .eps figure (Palette demo)").
     copyright("(C) 2006 LEMON Project").
     coords(hcoords).
@@ -189,5 +189,5 @@
     //    distantBWNodeTexts().
     nodeTexts(hcolors).nodeTextSize(.6).
-    nodeColors(composeMap(colorSet,hcolors)).
+    nodeColors(composeMap(palette,hcolors)).
     run();
 
Index: demo/grid_ugraph_demo.cc
===================================================================
--- demo/grid_ugraph_demo.cc	(revision 1979)
+++ demo/grid_ugraph_demo.cc	(revision 2172)
@@ -93,5 +93,5 @@
     nodeScale(0.5).
     drawArrows().
-    edgeColors(composeMap(ColorSet(), path)).
+    edgeColors(composeMap(Palette(), path)).
     run();
   
Index: demo/topology_demo.cc
===================================================================
--- demo/topology_demo.cc	(revision 2116)
+++ demo/topology_demo.cc	(revision 2172)
@@ -57,5 +57,5 @@
     run();
   
-  ColorSet colorSet;
+  Palette palette;
 
   Graph::NodeMap<int> compMap(graph);
@@ -65,5 +65,5 @@
     coords(coords).scaleToA4().enableParallel().
     parEdgeDist(20.0).edgeWidthScale(2.0).nodeScale(20.0).
-    nodeColors(composeMap(colorSet, compMap)).run();
+    nodeColors(composeMap(palette, compMap)).run();
 
   std::cout << "Result: connected_components.eps" << std::endl;
@@ -82,5 +82,5 @@
     run();
   
-  ColorSet colorSet;
+  Palette palette;
 
   Graph::NodeMap<int> compMap(graph);
@@ -93,5 +93,5 @@
     drawArrows().arrowWidth(10.0).arrowLength(10.0).
     parEdgeDist(20.0).edgeWidthScale(2.0).nodeScale(20.0).
-    nodeColors(composeMap(colorSet, compMap)).
+    nodeColors(composeMap(palette, compMap)).
     edgeColors(composeMap(functorMap(&color), cutMap)).run();
 
@@ -112,5 +112,5 @@
     run();
 
-  ColorSet colorSet;
+  Palette palette;
 
   Graph::UEdgeMap<int> compMap(graph);
@@ -122,5 +122,5 @@
     coords(coords).scaleToA4().enableParallel().
     parEdgeDist(20.0).edgeWidthScale(5.0).nodeScale(20.0).
-    edgeColors(composeMap(colorSet, compMap)).
+    edgeColors(composeMap(palette, compMap)).
     nodeColors(composeMap(functorMap(&color), cutMap)).
     run();
@@ -142,5 +142,5 @@
     run();
   
-  ColorSet colorSet;
+  Palette palette;
 
   Graph::NodeMap<int> compMap(graph);
@@ -152,5 +152,5 @@
     coords(coords).scaleToA4().enableParallel().
     parEdgeDist(20.0).edgeWidthScale(2.0).nodeScale(20.0).
-    nodeColors(composeMap(colorSet, compMap)).
+    nodeColors(composeMap(palette, compMap)).
     edgeColors(composeMap(functorMap(&color), cutMap)).run();
   
@@ -171,5 +171,5 @@
     run();
   
-  ColorSet colorSet;
+  Palette palette;
 
   Graph::NodeMap<bool> partMap(graph);
Index: doc/graph_orientation.dox
===================================================================
--- doc/graph_orientation.dox	(revision 2158)
+++ doc/graph_orientation.dox	(revision 2172)
@@ -54,7 +54,20 @@
 \skipline namespace
 
-The following <tt>typedef</tt>s will also save a lot of typing.
-\skip typedef
-\until InEdgeIt
+The following macro will also save a lot of typing by defining some
+convenience <tt>typedef</tt>s.
+
+\skipline TYPEDEF
+
+Actually, the macro above would be equivalent with the following
+<tt>typedef</tt>s.
+
+\code
+typedef ListGraph::Node Node;
+typedef ListGraph::NodeIt NodeIt;
+typedef ListGraph::Edge Edge;
+typedef ListGraph::EdgeIt EdgeIt;
+typedef ListGraph::OutEdgeIt OutEdgeIt;
+typedef ListGraph::InEdgeIt InEdgeIt;
+\endcode
 
 \subsection go-alg-main The main() function
@@ -153,5 +166,5 @@
 \c rev are transformed into different \ref lemon::Color "RGB color"s
 using the class
-\ref lemon::ColorSet "ColorSet"
+\ref lemon::Palette "Palette"
 and the \ref map_adaptors "map adaptor" called
 \ref lemon::ComposeMap "composeMap".
Index: lemon/color.h
===================================================================
--- lemon/color.h	(revision 2159)
+++ lemon/color.h	(revision 2172)
@@ -82,5 +82,5 @@
 ///change the actual colors.
 
-class ColorSet : public MapBase<int,Color>
+class Palette : public MapBase<int,Color>
 {
   std::vector<Color> colors;
@@ -97,5 +97,5 @@
   ///the color list is filled repeatedly with the default color list.
   ///(The colors can be changed later on.)
-  ColorSet(bool have_white=false,int num=0)
+  Palette(bool have_white=false,int num=0)
   {
     do {
Index: lemon/graph_to_eps.h
===================================================================
--- lemon/graph_to_eps.h	(revision 2084)
+++ lemon/graph_to_eps.h	(revision 2172)
@@ -427,5 +427,5 @@
   ///\param x must be a node map with \ref Color values.
   ///
-  ///\sa ColorSet
+  ///\sa Palette
   template<class X> GraphToEps<NodeColorsTraits<X> >
   nodeColors(const X &x)
@@ -443,5 +443,5 @@
   ///\param x must be a node map with \ref Color values. 
   ///
-  ///\sa ColorSet
+  ///\sa Palette
   template<class X> GraphToEps<NodeTextColorsTraits<X> >
   nodeTextColors(const X &x)
@@ -461,5 +461,5 @@
   ///\param x must be a edge map with \ref Color values. 
   ///
-  ///\sa ColorSet
+  ///\sa Palette
   template<class X> GraphToEps<EdgeColorsTraits<X> >
   edgeColors(const X &x)