Index: lemon/topology.h
===================================================================
--- lemon/topology.h	(revision 2111)
+++ lemon/topology.h	(revision 2260)
@@ -26,6 +26,6 @@
 #include <lemon/maps.h>
 
-#include <lemon/concept/graph.h>
-#include <lemon/concept/ugraph.h>
+#include <lemon/concepts/graph.h>
+#include <lemon/concepts/ugraph.h>
 #include <lemon/concept_check.h>
 
@@ -54,5 +54,5 @@
   template <typename UGraph>
   bool connected(const UGraph& graph) {
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::NodeIt NodeIt;
     if (NodeIt(graph) == INVALID) return true;
@@ -79,5 +79,5 @@
   template <typename UGraph>
   int countConnectedComponents(const UGraph &graph) {
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::Node Node;
     typedef typename UGraph::Edge Edge;
@@ -127,8 +127,8 @@
   template <class UGraph, class NodeMap>
   int connectedComponents(const UGraph &graph, NodeMap &compMap) {
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::Node Node;
     typedef typename UGraph::Edge Edge;
-    checkConcept<concept::WriteMap<Node, int>, NodeMap>();
+    checkConcept<concepts::WriteMap<Node, int>, NodeMap>();
 
     typedef NullMap<Node, Edge> PredMap;
@@ -245,5 +245,5 @@
   template <typename Graph>
   bool stronglyConnected(const Graph& graph) {
-    checkConcept<concept::Graph, Graph>();
+    checkConcept<concepts::Graph, Graph>();
 
     typedef typename Graph::Node Node;
@@ -303,5 +303,5 @@
   template <typename Graph>
   int countStronglyConnectedComponents(const Graph& graph) {
-    checkConcept<concept::Graph, Graph>();
+    checkConcept<concepts::Graph, Graph>();
 
     using namespace _topology_bits;
@@ -372,8 +372,8 @@
   template <typename Graph, typename NodeMap>
   int stronglyConnectedComponents(const Graph& graph, NodeMap& compMap) {
-    checkConcept<concept::Graph, Graph>();
+    checkConcept<concepts::Graph, Graph>();
     typedef typename Graph::Node Node;
     typedef typename Graph::NodeIt NodeIt;
-    checkConcept<concept::WriteMap<Node, int>, NodeMap>();
+    checkConcept<concepts::WriteMap<Node, int>, NodeMap>();
 
     using namespace _topology_bits;
@@ -435,9 +435,9 @@
   template <typename Graph, typename EdgeMap>
   int stronglyConnectedCutEdges(const Graph& graph, EdgeMap& cutMap) {
-    checkConcept<concept::Graph, Graph>();
+    checkConcept<concepts::Graph, Graph>();
     typedef typename Graph::Node Node;
     typedef typename Graph::Edge Edge;
     typedef typename Graph::NodeIt NodeIt;
-    checkConcept<concept::WriteMap<Edge, bool>, EdgeMap>();
+    checkConcept<concepts::WriteMap<Edge, bool>, EdgeMap>();
 
     using namespace _topology_bits;
@@ -731,5 +731,5 @@
   template <typename UGraph>
   int countBiNodeConnectedComponents(const UGraph& graph) {
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::NodeIt NodeIt;
 
@@ -775,8 +775,8 @@
   int biNodeConnectedComponents(const UGraph& graph, 
 				UEdgeMap& compMap) {
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::NodeIt NodeIt;
     typedef typename UGraph::UEdge UEdge;
-    checkConcept<concept::WriteMap<UEdge, int>, UEdgeMap>();
+    checkConcept<concepts::WriteMap<UEdge, int>, UEdgeMap>();
 
     using namespace _topology_bits;
@@ -815,8 +815,8 @@
   template <typename UGraph, typename NodeMap>
   int biNodeConnectedCutNodes(const UGraph& graph, NodeMap& cutMap) {
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::Node Node;
     typedef typename UGraph::NodeIt NodeIt;
-    checkConcept<concept::WriteMap<Node, bool>, NodeMap>();
+    checkConcept<concepts::WriteMap<Node, bool>, NodeMap>();
 
     using namespace _topology_bits;
@@ -1058,5 +1058,5 @@
   template <typename UGraph>
   int countBiEdgeConnectedComponents(const UGraph& graph) { 
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::NodeIt NodeIt;
 
@@ -1101,8 +1101,8 @@
   template <typename UGraph, typename NodeMap>
   int biEdgeConnectedComponents(const UGraph& graph, NodeMap& compMap) { 
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::NodeIt NodeIt;
     typedef typename UGraph::Node Node;
-    checkConcept<concept::WriteMap<Node, int>, NodeMap>();
+    checkConcept<concepts::WriteMap<Node, int>, NodeMap>();
 
     using namespace _topology_bits;
@@ -1142,8 +1142,8 @@
   template <typename UGraph, typename UEdgeMap>
   int biEdgeConnectedCutEdges(const UGraph& graph, UEdgeMap& cutMap) { 
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::NodeIt NodeIt;
     typedef typename UGraph::UEdge UEdge;
-    checkConcept<concept::WriteMap<UEdge, bool>, UEdgeMap>();
+    checkConcept<concepts::WriteMap<UEdge, bool>, UEdgeMap>();
 
     using namespace _topology_bits;
@@ -1206,6 +1206,6 @@
     using namespace _topology_bits;
 
-    checkConcept<concept::Graph, Graph>();
-    checkConcept<concept::WriteMap<typename Graph::Node, int>, NodeMap>();
+    checkConcept<concepts::Graph, Graph>();
+    checkConcept<concepts::WriteMap<typename Graph::Node, int>, NodeMap>();
 
     typedef typename Graph::Node Node;
@@ -1248,6 +1248,6 @@
     using namespace _topology_bits;
 
-    checkConcept<concept::Graph, Graph>();
-    checkConcept<concept::ReadWriteMap<typename Graph::Node, int>, NodeMap>();
+    checkConcept<concepts::Graph, Graph>();
+    checkConcept<concepts::ReadWriteMap<typename Graph::Node, int>, NodeMap>();
 
     typedef typename Graph::Node Node;
@@ -1291,5 +1291,5 @@
   bool dag(const Graph& graph) {
 
-    checkConcept<concept::Graph, Graph>();
+    checkConcept<concepts::Graph, Graph>();
 
     typedef typename Graph::Node Node;
@@ -1332,5 +1332,5 @@
   template <typename UGraph>
   bool acyclic(const UGraph& graph) {
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::Node Node;
     typedef typename UGraph::NodeIt NodeIt;
@@ -1365,5 +1365,5 @@
   template <typename UGraph>
   bool tree(const UGraph& graph) {
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     typedef typename UGraph::Node Node;
     typedef typename UGraph::NodeIt NodeIt;
@@ -1403,5 +1403,5 @@
   template<typename UGraph>
   inline bool bipartite(const UGraph &graph){
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     
     typedef typename UGraph::NodeIt NodeIt;
@@ -1440,5 +1440,5 @@
   template<typename UGraph, typename NodeMap>
   inline bool bipartitePartitions(const UGraph &graph, NodeMap &partMap){
-    checkConcept<concept::UGraph, UGraph>();
+    checkConcept<concepts::UGraph, UGraph>();
     
     typedef typename UGraph::Node Node;