Index: NEWS
===================================================================
--- NEWS	(revision 2265)
+++ NEWS	(revision 2266)
@@ -1,3 +1,72 @@
 2006-10-27  Version 0.6 Released
+
+#Renamed:
+  *Undir -> U
+  *Minimum -> Min
+  *Work -> Aux
+  *UGraphExtender -> UndirectGraphExtender
+    -UGraphExtenders with changed meaning
+  *GridGraph -> GridUGraph
+  *UNDIRGRAPH_TYPEDEFS -> UGRAPH_TYPEDEFS
+  *LinearHeap -> BucketHeap
+  *UGraphBaseExtender -> UndirGraphExtender
+  *BpUGraphBaseExtender merged into BpUGraphExtender
+  *StaticGraph to Graph
+  *ColorSet to Palette
+  *xy -> dim2::Point
+  *DirPath to Path
+  *concept -> concepts (namespace & directory)
+
+#Reorganized:
+  *bootstrap: quiet option
+  *utility, invalid and traits moved to bits
+  *section readers moved to own group
+  *separate group for matrices
+  *single makefile
+  *glemon is moved to own repository
+  *graph_component.h -> graph_components.h
+  *reference to modules added
+  *disable assertions in default behaviour
+  *BiVariant moved to lemon/bits/variant.h
+  *using abort() instead of exit(1)
+
+#Taken out:
+  *SplitGraph is temporarly deleted
+  *SubBidirGraphAdaptor
+  *obsolote "id" map handling
+  *concepts for extendable and erasable graphs
+  *exceptionName()
+  *bezier.h
+  *functional interfaces
+  *UPath
+
+#Rewritten, modificated, improved
+  *UnionFindEnum revision
+  *countItems
+  *findEdges
+  *IncEdgeIt goes through on loop edges twice.
+  *mining of the clear in heaps
+  *SplitGraphAdaptor
+  *item sets are written in the order sorted by the labels
+  *make explicit constructors
+  *snapshot
+    -rewritten
+    -implemented for SmartUGraph an SmartBpUGraph
+  *Node/Edge::operator<() is required by the concept
+  *Graph Component concepts
+  *disabled the copy constructor and operator- of {List|Smart}[U]Graph.
+  *modificated interface: colType() functions
+  *made public what() in NodeSetError
+  *improvment in exception handling
+    -exception safe erase and clear handler
+    -proper exception handling in the SmartEdgeSet
+    -rethrow of exception missing 
+  *signaling alterations in BpUGraphs
+  *UnionFind
+    -takes less space
+    -UnionFindEnum
+      -changed interface
+  *updated the Path concept
+  *item readers and writers
 
 #New
@@ -76,73 +145,4 @@
     -some color constants added (BLACK, WHITE, RED etc)
     -absolute/relative node size/link width scaling
-
-#Taken out:
-  *SplitGraph is temporarly deleted
-  *SubBidirGraphAdaptor
-  *obsolote "id" map handling
-  *concepts for extendable and erasable graphs
-  *exceptionName()
-  *bezier.h
-  *functional interfaces
-  *UPath
-
-#Rewritten, modificated, improved
-  *UnionFindEnum revision
-  *countItems
-  *findEdges
-  *IncEdgeIt goes through on loop edges twice.
-  *mining of the clear in heaps
-  *SplitGraphAdaptor
-  *item sets are written in the order sorted by the labels
-  *make explicit constructors
-  *snapshot
-    -rewritten
-    -implemented for SmartUGraph an SmartBpUGraph
-  *Node/Edge::operator<() is required by the concept
-  *Graph Component concepts
-  *disabled the copy constructor and operator- of {List|Smart}[U]Graph.
-  *modificated interface: colType() functions
-  *made public what() in NodeSetError
-  *improvment in exception handling
-    -exception safe erase and clear handler
-    -proper exception handling in the SmartEdgeSet
-    -rethrow of exception missing 
-  *signaling alterations in BpUGraphs
-  *UnionFind
-    -takes less space
-    -UnionFindEnum
-      -changed interface
-  *updated the Path concept
-  *item readers and writers
-
-#Reorganized:
-  *bootstrap: quiet option
-  *utility, invalid and traits moved to bits
-  *section readers moved to own group
-  *separate group for matrices
-  *single makefile
-  *glemon is moved to own repository
-  *graph_component.h -> graph_components.h
-  *reference to modules added
-  *disable assertions in default behaviour
-  *BiVariant moved to lemon/bits/variant.h
-  *using abort() instead of exit(1)
-
-#Renamed:
-  *Undir -> U
-  *Minimum -> Min
-  *Work -> Aux
-  *UGraphExtender -> UndirectGraphExtender
-    -UGraphExtenders with changed meaning
-  *GridGraph -> GridUGraph
-  *UNDIRGRAPH_TYPEDEFS -> UGRAPH_TYPEDEFS
-  *LinearHeap -> BucketHeap
-  *UGraphBaseExtender -> UndirGraphExtender
-  *BpUGraphBaseExtender merged into BpUGraphExtender
-  *StaticGraph to Graph
-  *ColorSet to Palette
-  *xy -> dim2::Point
-  *DirPath to Path
-  *concept -> concepts (namespace & directory)
 
 #Compatibility issues: